'=============================================================================
'
'                   Copyright (c) 2022 Ingenieurbüro Thomas Hilkert
'                    Published - All rights reserved
'
'===============================================================================
'File description: Example for POST-Action (Buzz Wire Game)


Option Strict Off
Imports System
Imports System.IO.File
Imports System.IO
Imports System.Collections
Imports System.Text.RegularExpressions
Imports System.Collections.Generic
Imports NXOpen
Imports NXOpen.UF
Imports NXOpen.Utilities
Imports NXOpen.Assemblies
Imports System.Windows.Forms
Imports System.Environment
Imports NXOpenUI
Imports NXOpen.Features
Imports System.Linq
Imports System.Data.DataTable
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization.Formatters
Imports System.Text


Module Auswertung


    Public UserName As String = Environment.UserName

    Public Syslog As String = "C:\Users\" + UserName + "\AppData\Local\temp_buzzwire"
    Public Storage As String = "C:\temp_buzzwire\"
    Public Target As String = Storage
    Public fullPath As String

    Sub Main()

        Dim aFile As String
        Call FolderCreation(fullPath)
        aFile = (fullPath) + "\Temp_Daten.txt"
        If Len(Dir$(aFile)) > 0 Then
            Kill(aFile)
        End If

        Dim sLine As String = ""
        Dim arrText As New ArrayList()


        NewestFile()

        Dim TimeResult As String = System.IO.File.ReadAllLines("c:\temp_buzzwire\TempResults.txt")(0)
        Dim CountResult As String = System.IO.File.ReadAllLines("c:\temp_buzzwire\TempResults.txt")(1)

        Dim input = File.ReadAllText(Target + "Syslog_Kopie.txt")
        Dim pattern = "<DLC> Acknowledge Collisions"
        Dim matches = Regex.Matches(input, pattern)
        Dim countres = matches.Count

        Dim dub1 As Double = 0
        Double.TryParse(countres, dub1)

        Dim dub2 As Double = 0
        Double.TryParse(CountResult, dub2)

        Dim Diff As Double = (dub1 - dub2)

        Dim dateString_end = DateTime.Now.ToString("mm_ss")

        Dim expenddt1 As Date = Date.ParseExact(TimeResult, "mm_ss", System.Globalization.DateTimeFormatInfo.InvariantInfo)
        Dim expenddt2 As Date = Date.ParseExact(dateString_end, "mm_ss", System.Globalization.DateTimeFormatInfo.InvariantInfo)


        Dim diff2 As String = (expenddt2 - expenddt1).TotalMinutes.ToString()
        Dim vOut As Double
        vOut = CDbl(diff2 * 60)
        Dim vOutR As Double
        vOutR = Math.Round(vOut)
        Dim theUISession As UI = UI.GetUI
		Dim messages(4) As String
        messages(0) = "Collisions detected: " & Diff.ToString
        messages(1) = "Time required: " & vOutR & " " & "seconds"
        ' MsgBox("Collisions detected: " & Diff.ToString & vbCrLf & "Time required: " & vOutR & " " & "seconds")
        theUISession.NXMessageBox.Show("GetResult", NXMessageBox.DialogType.Information, messages)


        Dim FILE_NAME As String = "c:\temp_buzzwire\TempResults.txt"
        WriteToFile(FILE_NAME, "", countres)

    End Sub




    Function NewestFile()

        Dim FileName As String
        Dim MostRecentFile As String
        Dim MostRecentDate As Date
        Dim FileSpec As String
        'Dim fullPath As String
        Call FolderCreation(fullPath)

        'Specify the file type, if any
        FileSpec = UserName + "*.syslog"
        'specify the directory


        Dim WinDir = Environ$("TEMP")
        Dim Directory = WinDir + "\"
        FileName = Dir(Directory & FileSpec)


        If FileName <> "" Then
            MostRecentFile = FileName
            MostRecentDate = FileDateTime(Directory & FileName)
            Do While FileName <> ""
                If FileDateTime(Directory & FileName) > MostRecentDate Then
                    MostRecentFile = FileName
                    MostRecentDate = FileDateTime(Directory & FileName)
                End If
                FileName = Dir()
            Loop
        End If
        NewestFile = MostRecentFile
        Dim N As String = Directory + NewestFile


        FileCopy(N, (fullPath) + "\Syslog_Kopie.txt")

    End Function

    Sub FolderCreation(ByRef fullPath As String)

        fullPath = Path.Combine(Target)
        Directory.CreateDirectory(fullPath)

    End Sub

    Private Sub WriteToFile(FILE_NAME As String, Value1 As String, Value2 As String)

        If System.IO.File.Exists(FILE_NAME) = True Then

            Dim lines() As String = System.IO.File.ReadAllLines(FILE_NAME)
            Dim iLineCount As Integer = lines.Length
            Dim objWriter As New System.IO.StreamWriter(FILE_NAME, True)

            While iLineCount < 4
                objWriter.WriteLine("")
                iLineCount = iLineCount + 1
            End While
            objWriter.Close()

            lines = System.IO.File.ReadAllLines(FILE_NAME)
            lines(0) = Value1
            lines(1) = Value2

            System.IO.File.WriteAllLines(FILE_NAME, lines)

        Else
            MsgBox("File Does Not Exist")
        End If


    End Sub

End Module


Public Class Class1

End Class
